Index: src/common/core/memory.d
===================================================================
--- src/common/core/memory.d	(revision 185)
+++ src/common/core/memory.d	(working copy)
@@ -13,6 +13,7 @@
  */
 module core.memory;
 
+__gshared size_t[3] conservativeBitMask = [cast(size_t) 3, 1, 0];
 
 private
 {
@@ -28,9 +29,9 @@
     extern (C) uint gc_setAttr( void* p, uint a );
     extern (C) uint gc_clrAttr( void* p, uint a );
 
-    extern (C) void*  gc_malloc( size_t sz, uint ba = 0 );
-    extern (C) void*  gc_calloc( size_t sz, uint ba = 0 );
-    extern (C) void*  gc_realloc( void* p, size_t sz, uint ba = 0 );
+    extern (C) void*  gc_malloc( size_t sz, uint ba = 0, size_t* bitMask = conservativeBitMask.ptr);
+    extern (C) void*  gc_calloc( size_t sz, uint ba = 0, size_t* bitMask = conservativeBitMask.ptr );
+    extern (C) void*  gc_realloc( void* p, size_t sz, uint ba = 0, size_t* bitMask = null);
     extern (C) size_t gc_extend( void* p, size_t mx, size_t sz );
     extern (C) size_t gc_reserve( size_t sz );
     extern (C) void   gc_free( void* p );
@@ -43,6 +44,7 @@
         void*  base;
         size_t size;
         uint   attr;
+
     }
 
     extern (C) BlkInfo_ gc_query( void* p );
@@ -201,6 +203,7 @@
      * Params:
      *  sz = The desired allocation size in bytes.
      *  ba = A bitmask of the attributes to set on this block.
+     *  bitMask = The pointer offset information for precise heap scanning.
      *
      * Returns:
      *  A reference to the allocated memory or null if insufficient memory
@@ -209,9 +212,10 @@
      * Throws:
      *  OutOfMemoryException on allocation failure.
      */
-    static void* malloc( size_t sz, uint ba = 0 )
+    static void* malloc( size_t sz, uint ba = 0,
+        const(size_t)* bitMask = conservativeBitMask.ptr )
     {
-        return gc_malloc( sz, ba );
+        return gc_malloc( sz, ba, cast(size_t*) bitMask );
     }
 
 
@@ -226,6 +230,7 @@
      * Params:
      *  sz = The desired allocation size in bytes.
      *  ba = A bitmask of the attributes to set on this block.
+     *  bitMask = The pointer offset information for precise heap scanning.
      *
      * Returns:
      *  A reference to the allocated memory or null if insufficient memory
@@ -234,9 +239,10 @@
      * Throws:
      *  OutOfMemoryException on allocation failure.
      */
-    static void* calloc( size_t sz, uint ba = 0 )
+    static void* calloc( size_t sz, uint ba = 0,
+        const(size_t)* bitMask = conservativeBitMask.ptr )
     {
-        return gc_calloc( sz, ba );
+        return gc_calloc( sz, ba, cast(size_t*) bitMask );
     }
 
 
@@ -258,12 +264,15 @@
      * reallocation is required.  If ba is not zero and p references the head
      * of a valid, known memory block then the bits in ba will replace those on
      * the current memory block and will also be set on the new block if a
-     * reallocation is required.
+     * reallocation is required.  Similarly, if bitMask is non-null, then
+     * the bitmask for the current block will propagated to the new block.
+     * Otherwise, the bitmask provided will be propagated to the old block.
      *
      * Params:
      *  p  = A pointer to the root of a valid memory block or to null.
      *  sz = The desired allocation size in bytes.
      *  ba = A bitmask of the attributes to set on this block.
+     *  bitMask = The pointer offset information for precise heap scanning.
      *
      * Returns:
      *  A reference to the allocated memory on success or null if sz is
@@ -272,9 +281,10 @@
      * Throws:
      *  OutOfMemoryException on allocation failure.
      */
-    static void* realloc( void* p, size_t sz, uint ba = 0 )
+    static void* realloc( void* p, size_t sz, uint ba = 0,
+        size_t* bitMask = null )
     {
-        return gc_realloc( p, sz, ba );
+        return gc_realloc( p, sz, ba, cast(size_t*) bitMask );
     }
 
 
